package jp.gihyo.mitoma.careMember;

import android.content.Context;
import android.os.Bundle;
import android.preference.EditTextPreference;
import android.preference.Preference;
import android.preference.PreferenceActivity;
import android.preference.PreferenceManager;
import android.preference.Preference.OnPreferenceChangeListener;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.widget.Toast;
import jp.gihyo.mitoma.careMember.R;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class PreferencesCont extends PreferenceActivity{
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        //ݒʂ̕\
        addPreferencesFromResource(R.xml.preferences);
        //̃vWFNgQƉƂ郂[hɐݒ
        getPreferenceManager().setSharedPreferencesMode(MODE_WORLD_READABLE|MODE_WORLD_WRITEABLE);
        //ZLeBR[h͎̃`FbN̓o^
        EditTextPreference etp = 
        		(EditTextPreference)findPreference(getString(R.string.secure_code));
        etp.setOnPreferenceChangeListener(new OnPreferenceChangeListener() {			
			public boolean onPreferenceChange(Preference preference, Object newValue) {
				String code=(String)newValue;
				if(!code.matches("[0-9]+")){
					Toast.makeText(PreferencesCont.this,
							"ZLeBR[ȟ",Toast.LENGTH_LONG).show();
				}
				return true;
			}
		});
        
    }
    /* *********************************************
     * Qb^[({ݒt@Cl擾)
     ************************************************/
    public static String getSecureCode(Context con){
    	return PreferenceManager.getDefaultSharedPreferences(con)
    			.getString("secure_code", "00000"); 
    }
    public static boolean isRemote(Context con){
    	return PreferenceManager.getDefaultSharedPreferences(con)
    			.getBoolean("remote", false);    	
    }
    public static String getServer(Context con){
    	return PreferenceManager.getDefaultSharedPreferences(con)
    			.getString("server", "non");    	
    }
    public static String getStorage(Context con){
    	return PreferenceManager.getDefaultSharedPreferences(con)
    			.getString("storage", "non");    	
    }
    public static String getSaveCode(Context con){
    	return PreferenceManager.getDefaultSharedPreferences(con)
    			.getString("savecode", "utf-8");    	
    }
    public static String getResource(Context con){
    	return PreferenceManager.getDefaultSharedPreferences(con)
    			.getString("dbinit", "non");    	
    }
    /* *********************************************
     * IvVj[̕\
     ************************************************/
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
	  	super.onCreateOptionsMenu(menu);
	  	MenuInflater inflater = getMenuInflater();
	  	inflater.inflate(R.menu.main_second, menu);
	  	return true;
	}
	/* *********************************************
     * IvVj[̏(I)
     ************************************************/
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
	  	super.onOptionsItemSelected(item);	
	  	this.finish();
	  	return true;
	}
}
    