package jp.gihyo.mitoma.careMember.model;
import java.util.ArrayList;

import android.content.ContentResolver;
import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.net.Uri;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class MemberProvDAO implements MemberDAOInterface{
	private ContentResolver resolver;
	private static final String PROV_URI = "content://jp.gihyo.mitoma.caretimer.provider.dbprovider/member";
	private Uri uri;
    public MemberProvDAO(Context context){
        this.resolver=context.getContentResolver();
        this.uri=Uri.parse(PROV_URI);
    }
    public MemberDTO selectOne(String key){
    	MemberDTO dto=new MemberDTO();
    	String[] select={"memNo","memName","memGender",
    			"memBirthday","memPref","memEmail","memTel",
    			"memLevel","memLatitude","memLongitude"};
    	String where="memNo='"+key+"'";
    	String[] whereArgs=null;
    	String orderBy="memNo";
        Cursor cursor=resolver.query(this.uri,select,where,whereArgs,orderBy);
        if (cursor.moveToFirst()){
	        dto.setMemNo(cursor.getString(0));
	        dto.setMemName(cursor.getString(1));
	        dto.setMemGender(cursor.getString(2));
	        dto.setMemBirthday(cursor.getString(3));
	        dto.setMemPref(cursor.getString(4));
	        dto.setMemEmail(cursor.getString(5));
	        dto.setMemTel(cursor.getString(6));
	        dto.setMemLevel(cursor.getString(7));
	        dto.setMemLatitude(cursor.getString(8));
	        dto.setMemLongitude(cursor.getString(9));
        }
        cursor.close();
        return dto;
    }
    public ArrayList<MemberDTO> selectSome(String[] terms){
    	ArrayList<MemberDTO> list=new ArrayList<MemberDTO>();
    	String[] select={"memNo","memName","memGender",
    			"memBirthday","memPref","memEmail","memTel",
    			"memLevel","memLatitude","memLongitude"};
    	String where=null;
    	String[] whereArgs=null;
    	String orderBy="memNo asc";
    	Cursor cursor=resolver.query(this.uri,select,where,whereArgs,orderBy);
        while(cursor.moveToNext()){
        	MemberDTO dto=new MemberDTO();
	        dto.setMemNo(cursor.getString(0));
	        dto.setMemName(cursor.getString(1));
	        dto.setMemGender(cursor.getString(2));
	        dto.setMemBirthday(cursor.getString(3));
	        dto.setMemPref(cursor.getString(4));
	        dto.setMemEmail(cursor.getString(5));
	        dto.setMemTel(cursor.getString(6));
	        dto.setMemLevel(cursor.getString(7));
	        dto.setMemLatitude(cursor.getString(8));
	        dto.setMemLongitude(cursor.getString(9));
	        list.add(dto);
        }
        cursor.close();
    	return list;
    }
    public int delete(String key){
    	String where="memNo='"+key+"'";
    	return resolver.delete(this.uri,where,null);
    }
    public int deleteAll(){    	
    	return resolver.delete(this.uri,null,null);
    }
    public int insert(MemberDTO dto){
    	MemberDTO dtoEx=this.selectOne(dto.getMemNo());
    	if(!dtoEx.getMemNo().equals(""))return -1;
    	ContentValues values=new ContentValues();    	
        values.put("memNo",dto.getMemNo());
        values.put("memName",dto.getMemName());        
        values.put("memGender",dto.getMemGender());
        values.put("memBirthday",dto.getMemBirthday());
        values.put("memPref",dto.getMemPref());        
        values.put("memEmail",dto.getMemEmail());
        values.put("memTel",dto.getMemTel());
        values.put("memLevel",dto.getMemLevel());
        values.put("memLatitude",dto.getMemLatitude());
        values.put("memLongitude",dto.getMemLongitude());
        resolver.insert(this.uri,values);
        return 1;
    }

    //s̍XV
    public int update(MemberDTO dto){
    	String where="memNo="+dto.getMemNo();
    	String[] whereArgs=null;
        ContentValues values=new ContentValues();
        values.put("memName",dto.getMemName());        
        values.put("memGender",dto.getMemGender());
        values.put("memBirthday",dto.getMemBirthday());
        values.put("memPref",dto.getMemPref());        
        values.put("memEmail",dto.getMemEmail());
        values.put("memTel",dto.getMemTel());
        values.put("memLevel",dto.getMemLevel());
        values.put("memLatitude",dto.getMemLatitude());
        values.put("memLongitude",dto.getMemLongitude());
        return resolver.update(this.uri,values,where,whereArgs);
    }
    public int insertSome(ArrayList<MemberDTO> list){
    	//
    	return 0;
    }
}
