package jp.gihyo.mitoma.careTimerV01.activity;

import java.util.ArrayList;
import java.util.Calendar;

import jp.gihyo.mitoma.careTimerV01.activity.PreferencesCont;
import jp.gihyo.mitoma.careTimerV01.activity.model.CareBean;
import jp.gihyo.mitoma.careTimerV01.activity.model.CareDTO;
import jp.gihyo.mitoma.careTimerV01.util.DialogUtil;
import jp.gihyo.mitoma.careTimer.R;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.text.format.DateFormat;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class CareControl extends Activity{
//	private static final String LOGC = "CareControl:";
    private CareView view;
    private CareBean bean;
    private String date;
    private String memNo;
    private String memName;
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Calendar now = Calendar.getInstance();
    	this.date=(String) DateFormat.format(this.getString(R.string.fdate_f),now);
    	if(PreferencesCont.getMemberNo(this).equals("none"))DialogUtil.showDialog(this, "xI", "{ݒĉ");
    }
    @Override
    public void onResume() {
        super.onResume();
        this.memNo=PreferencesCont.getMemberNo(this);
    	this.memName=PreferencesCont.getMemberName(this);
        view=new CareView(this);        
    	bean=new CareBean(this,this.memNo,this.date);    	
    	if(!bean.isCareExist()){
    		DialogUtil.showDialog(this, "xI", "vȂ");
    		bean.setMemNo(this.memNo);
    		bean.setMemName(this.memName);
    	}
    	bean.setHelperCode(PreferencesCont.getHelpreCode(this));
    	bean.setHelperName(PreferencesCont.getHelpreName(this));
    	bean.setDate(this.date);
    	view.setHeader(bean);
    	view.setDetail(bean.getCareMatter());
    }
    @Override
    public void onPause() {
        super.onPause();
        ArrayList<CareDTO> perform=view.getDetail();        
        bean.setCareMatter(perform);
        bean.careUpdate();
    }
    @Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
	  	super.onCreateOptionsMenu(menu);
	  	MenuInflater inflater = getMenuInflater();
	  	inflater.inflate(R.menu.main, menu);
	  	return true;
	}
  	@Override
  	public boolean onOptionsItemSelected(MenuItem item) {
  	  	super.onOptionsItemSelected(item);
  	  	Intent intent;
  	  	switch (item.getItemId()){
  	  	case R.id.optmenu_schedule:
  	  		//쐬
  	  		break;
  		case R.id.optmenu_history:
  			intent = new Intent(this, jp.gihyo.mitoma.careTimerV01.activity.CareHistoryCont.class);
  	  		startActivity(intent);
  	  		break;
  		case R.id.optmenu_preferences:
  	  		intent = new Intent(this, jp.gihyo.mitoma.careTimerV01.activity.PreferencesCont.class);
  	  		startActivity(intent);
  	  		break;
  	  	case R.id.optmenu_close:
  	  		finish();
  	  		break;
  	  	}	  	
  	  	return true;
  	}
    public void onTouch(View v) {view.dialogInput(v);}
}