package jp.gihyo.android.exercise03;
import java.util.ArrayList;
import java.util.Calendar;

import jp.gihyo.android.exercise.R;
import jp.gihyo.android.exercise03.model.CareBean;
import jp.gihyo.android.exercise03.model.CareDTO;
import jp.gihyo.android.exercise03.view.CarePlanView;
import android.app.Activity;
import android.content.ComponentName;
import android.content.Intent;
import android.os.Bundle;
import android.text.format.DateFormat;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class CarePlanControl extends Activity {
	private CarePlanView planView;
	private CareBean careBean;
	private String date;
	private String memNo;
	private String memName;
	private int lineNo;
     @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //̓tҏW
        Calendar now = Calendar.getInstance();
     	this.date=(String) DateFormat.format("yyyy/MM/dd",now);
     	//̃tB[h̏
     	this.memNo="000000";
       	this.memName="ݒ";
        this.lineNo=0;
     }
     @Override
     public void onResume() {
         super.onResume();
         //r[𐶐ԍƉ\
         planView=new CarePlanView(this);
         planView.setMemNo(this.memNo);
         planView.setMemName(this.memName);
         
         //r[𐶐C̉vƉ
         careBean=new CareBean();
         careBean.careInquiry(this.memNo,this.date);
         
         //v̐擪\
         this.lineNo=0;
         if(careBean.isCareExist()&& careBean.getCareMatter()!=null){
        	 this.dispDTO(careBean.getCareMatter(),this.lineNo);
         }         
      }
     @Override
     public void onPause() {
         super.onPause();
         //쐬
     }
     /* *********************************************
      * IvVj[̍쐬
      ************************************************/
     @Override
 	public boolean onCreateOptionsMenu(android.view.Menu menu) {
 	  	super.onCreateOptionsMenu(menu);
 	  	MenuInflater inflater = getMenuInflater();
 	  	inflater.inflate(R.menu.main, menu);
 	  	return true;
 	}
     /* *********************************************
      * IvVj[Cxg
      ************************************************/ 
   	@Override
   	public boolean onOptionsItemSelected(MenuItem item) {
   	  	super.onOptionsItemSelected(item);
   	  	switch (item.getItemId()){
   	 case R.id.optmenu_dbout:
	  		//쐬
	  		break;
   	  	case R.id.optmenu_dbinit:
   	  		//쐬
   	  		break;
   	  	case R.id.optmenu_close:
   	  		finish();
   	  		break;
   	  	}	  	
   	  	return true;
   	}
    /* *********************************************
     * \莞&{^b`Cxg
     ************************************************/
    public void onTouch(View v) {
       planView.dialogInput(v);
    }
    /* *********************************************
     * {^^b`Cxg
     ************************************************/
    public void onClick(View v) {
    	switch(v.getId()){
    	//擪
    	case R.id.btn0:
    		this.lineNo=0;
    		this.dispDTO(careBean.getCareMatter(),this.lineNo);
    		break;
    	//
    	case R.id.btn1:
    		if(++this.lineNo>=careBean.getCareMatter().size())
    			this.lineNo=careBean.getCareMatter().size()-1;
    		this.dispDTO(careBean.getCareMatter(),this.lineNo);
    		break;
    	//߂
    	case R.id.btn2:
    		if(--this.lineNo<0)this.lineNo=0;
    		this.dispDTO(careBean.getCareMatter(),this.lineNo);
    		break;
    	//Ґݒ
    	case R.id.btn3:
    		Intent intent = new Intent();
    		ComponentName compo=new ComponentName("jp.gihyo.mitoma.careMember", "jp.gihyo.mitoma.careMember.MemberListCont");
	  		intent.setComponent(compo);
	  		startActivityForResult(intent,0);
    		break;
    	//ǉ
    	case R.id.btn4:
    		//쐬
    		break;
    	//ύX
    	case R.id.btn5:
    		//쐬
    		break;
    	//폜	
    	case R.id.btn6:
    		//쐬
    		break;
    	//v揉
    	case R.id.btn7:
    		//***fobOp(CareBeanɂ͊O)************
    		careBean.careInit();
    		//******************************************
    		//擪\
    		this.lineNo=0;
    		this.dispDTO(careBean.getCareMatter(),this.lineNo);
    		break;
    	}
    }
    /* *********************************************
     * ꗗʂ̖߂̏
     ************************************************/
	@Override
	protected void onActivityResult(int reqCode,int resultCode,Intent intent){
		if(resultCode==RESULT_OK){
			try{
				//Intentf[^̎oƕ\
				this.memNo=(String)intent.getStringExtra("memNo");
				this.memName=intent.getStringExtra("memName");
		         planView.setMemNo(this.memNo);
		         planView.setMemName(this.memName);
		         
		         //̉vƉ
		         careBean.careInquiry(this.memNo,this.date);
		         
		         //v̐擪\
		         this.lineNo=0;
		         if(careBean.isCareExist()&& careBean.getCareMatter()!=null){
		        	 this.dispDTO(careBean.getCareMatter(),this.lineNo);
		         }
		    }catch(Exception e){
				
			}
		 }
	}
    /* *********************************************
     * ArrayListwsCareDTȎSڂ܂Ƃ߂ĕ\
     ************************************************/
    private void dispDTO(ArrayList<CareDTO> list,int line){
    	if(list==null)return;
    	if(list.isEmpty()||list.size()<line+1||line<0)return;
    	CareDTO dto=list.get(line);
    	planView.setCareCode(dto.getCareCode());
    	planView.setCareName(dto.getCareName());
    	planView.setPlanNo(dto.getPlanNo());
    	planView.setPredTime(dto.getPredTime());
    	planView.setImplTime(dto.getImplTime());
    	planView.setResult(dto.getResult());
    }
}