package jp.gihyo.android.exercise09;
import java.util.ArrayList;
import java.util.Calendar;

import jp.gihyo.android.exercise.R;
import jp.gihyo.android.exercise09.model.CareBean;
import jp.gihyo.android.exercise09.model.CareDTO;
import jp.gihyo.android.exercise09.model.CareMainte;
import jp.gihyo.android.exercise09.view.CarePlanView;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.text.format.DateFormat;
import android.view.GestureDetector;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.GestureDetector.OnGestureListener;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class CarePlanControl extends Activity  implements OnGestureListener{
	private CarePlanView planView;
	private CareBean careBean;
	private CareMainte careMainte;
	private String date;
	private String memNo;
	private String memName;
	private int lineNo;
	private GestureDetector detector;
	
     @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //̓tҏW
        Calendar now = Calendar.getInstance();
     	this.date=(String) DateFormat.format("yyyy/MM/dd",now);
     	
     	//Jڌ瑗ꂽIntent̉ԍƉo
        Intent intent=getIntent();
        this.memNo=intent.getStringExtra("memNo");
        this.memName=intent.getStringExtra("memName");
        if(this.memNo==null)this.memNo="000000";
        if(this.memName==null)this.memName="ݒ";

        Intent newIntent=new Intent("jp.gihyo.exercise.carePlan.CARE_PLAN_CHECK");
        startService(newIntent);
        this.detector=new GestureDetector(this,this);
     }
     @Override
     public void onResume() {
         super.onResume();
         //r[𐶐ԍƉ\
         planView=new CarePlanView(this);
         planView.setMemNo(this.memNo);
         planView.setMemName(this.memName);
         
         //w̖{̃r[𐶐
         careBean=new CareBean(this,this.memNo,this.date);
         
         //v̐擪\
         this.lineNo=0;
         if(careBean.isCareExist()&& careBean.getCareMatter()!=null){
        	 this.dispDTO(careBean.getCareMatter(),this.lineNo);
         }
       //CateMainte𐶐
         careMainte=new CareMainte(this);
      }
     @Override
     public void onPause() {
         super.onPause();         
         //쐬
     }
     /* *********************************************
      * IvVj[̍쐬
      ************************************************/
     @Override
 	public boolean onCreateOptionsMenu(android.view.Menu menu) {
 	  	super.onCreateOptionsMenu(menu);
 	  	MenuInflater inflater = getMenuInflater();
 	  	inflater.inflate(R.menu.main, menu);
 	  	return true;
 	}
     /* *********************************************
      * IvVj[Cxg
      ************************************************/ 
   	@Override
   	public boolean onOptionsItemSelected(MenuItem item) {
   		
   	  	super.onOptionsItemSelected(item);
   	  	switch (item.getItemId()){
   		case R.id.optmenu_dbout:
   			/* ***********************************************
    		 * Ƀvԍ_ũ`FbN
    		 **************************************************/
    		/* ***********************************************
    		 * Ƀvԍ_ũ`FbN
    		 **************************************************/
    		for(int i=0;i<careBean.getCareMatter().size();i++){
    			CareDTO careDto=careBean.getCareMatter().get(i);
    			careDto.setMemNo(this.memNo);
    			careDto.setMemName(this.memName);
    			careDto.setDate(this.date);
    		}
    		careBean.careRegist();
    		break;
   	  	case R.id.optmenu_dbinit:
   	  		careMainte.dbClear();
   	  		break;
   	  	case R.id.optmenu_close:
   	  		finish();
   	  		break;
   	  	}	  	
   	  	return true;
   	}
    /* *********************************************
     * \莞&{^b`Cxg
     ************************************************/
    public void onTouch(View v) {
       planView.dialogInput(v);
    }
    /* *********************************************
     * {^^b`Cxg
     ************************************************/
    public void onClick(View v) {
    	CareDTO careDto;
    	Intent intent = new Intent();
    	switch(v.getId()){
    	//ǉ
    	case R.id.btn4:    		
    		/* ***********************************************
    		 * Ƀvԍ_ũ`FbN
    		 **************************************************/
    		/* ***********************************************
    		 * ɒǉmF̃_CAO\鏈
    		 **************************************************/
    		careDto=new CareDTO();
    		//ʃf[^̎荞
    		careDto.setCareCode(planView.getCareCode());
    		careDto.setCareName(planView.getCareName());
    		careDto.setPlanNo(planView.getPlanNo());
    		careDto.setPredTime(planView.getPredTime());
    		careDto.setImplTime(planView.getImplTime());
    		careDto.setResult(planView.getResult());
    		//ArrayList֒ǉ
    		careBean.getCareMatter().add(careDto);
    		//ArrayListvԍɕׂ
    		arraySort(careBean.getCareMatter());
    		//T[rX̌Ăяo
    		intent.setAction("jp.gihyo.exercise.carePlan.INSERT");
    		intent.putExtra("careDTO", careDto);	  		  		
		  	intent.putExtra("procType","INSERT");		  	
	  		startService(intent);
    		break;
    	//ύX
    	case R.id.btn5:
    		/* ***********************************************
    		 * ɕύXmF̃_CAO\鏈
    		 **************************************************/
    		careDto=careBean.getCareMatter().get(this.lineNo);
    		//ʃf[^̎荞
    		careDto.setCareCode(planView.getCareCode());
    		careDto.setCareName(planView.getCareName());
    		careDto.setPlanNo(planView.getPlanNo());
    		careDto.setPredTime(planView.getPredTime());
    		careDto.setImplTime(planView.getImplTime());
    		careDto.setResult(planView.getResult());
    		//ArrayListvԍɕׂ
    		arraySort(careBean.getCareMatter());
    		//T[rX̌Ăяo
    		intent.setAction("jp.gihyo.exercise.carePlan.UPDATE");
    		intent.putExtra("careDTO", careDto);	  		  		
		  	intent.putExtra("procType","UPDATE");		  	
	  		startService(intent);
    		break;
    	//폜	
    	case R.id.btn6:
    		/* ***********************************************
    		 * ɍ폜mF̃_CAO\鏈
    		 **************************************************/
    		careDto=careBean.getCareMatter().get(this.lineNo);
    		careBean.getCareMatter().remove(this.lineNo);
    		//T[rX̌Ăяo
    		intent.setAction("jp.gihyo.exercise.carePlan.DELETE");
    		intent.putExtra("careDTO", careDto);	  		  		
		  	intent.putExtra("procType","DELETE");		  	
	  		startService(intent);
    		break;
    	//v揉
    	case R.id.btn7:
    		//v̐`Ǎ݁CcareBeanɃZbg
    		careBean.setCareMatter(careMainte.getBasicPlan());
    		//擪\
    		this.lineNo=0;
    		this.dispDTO(careBean.getCareMatter(),this.lineNo);
    		//T[rX̌Ăяo
    		intent.setAction("jp.gihyo.exercise.carePlan.INSERT");    			  		  		
		  	intent.putExtra("procType","INSERT");
    		for(int i=0;i<careBean.getCareMatter().size();i++){
    			intent.putExtra("careDTO", careBean.getCareMatter().get(i));
    			startService(intent);
    		}
    		break;
    	}
    }
    /* *********************************************
     * ꗗ̖߂̏
     ************************************************/
	@Override
	protected void onActivityResult(int reqCode,int resultCode,Intent intent){
		if(resultCode==RESULT_OK){
			try{
				this.memNo=intent.getStringExtra("memNo");
				this.memName=intent.getStringExtra("memName");
		         planView.setMemNo(this.memNo);
		         planView.setMemName(this.memName);
		         
		         //̉vƉ
		         careBean.careInquiry(this.memNo,this.date);
		         
		         //v̐擪\
		         this.lineNo=0;
		         if(careBean.isCareExist()&& careBean.getCareMatter()!=null){
		        	 this.dispDTO(careBean.getCareMatter(),this.lineNo);
		         }         

			}catch(Exception e){
				
			}
		 }
	}
    /* *********************************************
     * ArrayListwsCareDTȎSڂ܂Ƃ߂ĕ\
     ************************************************/
    private void dispDTO(ArrayList<CareDTO> list,int line){
    	if(list==null)return;
    	if(list.isEmpty()||list.size()<line+1||line<0)return;
    	CareDTO dto=list.get(line);
    	planView.setCareCode(dto.getCareCode());
    	planView.setCareName(dto.getCareName());
    	planView.setPlanNo(dto.getPlanNo());
    	planView.setPredTime(dto.getPredTime());
    	planView.setImplTime(dto.getImplTime());
    	planView.setResult(dto.getResult());
    }
    /* *********************************************
     * ArrayListvԍɕׂ
     ************************************************/
    private void arraySort(ArrayList<CareDTO> list){
    	CareDTO work;
    	for(int i=0;i<list.size()-1;i++){
    		for(int j=i+1;j<list.size();j++){
    			if(list.get(i).getPlanNo().compareToIgnoreCase(list.get(j).getPlanNo())>0){
    				work=list.get(i);
    				list.set(i, list.get(j));
    				list.set(j, work);
    			}
    		}
    	}    		
    }
    /* *********************************************
     * WFX`Cxg
     ************************************************/
    @Override
    public boolean onTouchEvent(MotionEvent event){
    	detector.onTouchEvent(event);
      	super.onTouchEvent(event);
    	return true;
    }
    //tbN
	public boolean onFling(MotionEvent event0, MotionEvent event1, float xSpeed,
			float ySpeed) {
		//tbN(v𑝉)
		if(xSpeed<-800){
    		if(++this.lineNo>=careBean.getCareMatter().size())
    			this.lineNo=careBean.getCareMatter().size()-1;
    		this.dispDTO(careBean.getCareMatter(),this.lineNo);
		}
		//tbN(v)
		if(xSpeed>800){
			if(--this.lineNo<0)
    			this.lineNo=0;
    		this.dispDTO(careBean.getCareMatter(),this.lineNo);
		}
		return true;
	}
	//O^b`(ꗗ\ɑJ)
	public void onLongPress(MotionEvent e) {
		Intent intent=new Intent("jp.gihyo.mitoma.careMember.LIST_VIEW");
  		startActivityForResult(intent,0);
	}
	//ȉ͋󃁃\bh
	public boolean onDown(MotionEvent e) {return false;}
	public boolean onScroll(MotionEvent e1, MotionEvent e2, float distanceX,
			float distanceY) {return false;}
	public void onShowPress(MotionEvent e) {}
	public boolean onSingleTapUp(MotionEvent e) {return false;}    
}