package jp.gihyo.mitoma.careMember.model;
import java.util.ArrayList;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class MemberDAO implements MemberDAOInterface{
	private SQLiteDatabase db;
    private final static String DB_TABLE = "member";
    public MemberDAO(Context context){
    	this.db=DbConnect.getInstance(context)
    			.getWritableDatabase();
    }
    /* *********************************************
     *@
     ************************************************/
    public MemberDTO selectOne(String key){
    	MemberDTO dto=new MemberDTO();
    	String[] select={"memNo","memName","memGender",
    			"memBirthday","memPref","memEmail","memTel",
    			"memLevel","memLatitude","memLongitude"};
    	String where="memNo='"+key+"'";
    	String[] whereArgs=null;
    	String groupBy=null;
    	String having=null;
    	String orderBy="memNo";
        Cursor cursor=db.query(DB_TABLE,select,where,whereArgs,groupBy,having,orderBy);
        if (cursor.moveToFirst()){
	        dto.setMemNo(cursor.getString(0));
	        dto.setMemName(cursor.getString(1));
	        dto.setMemGender(cursor.getString(2));
	        dto.setMemBirthday(cursor.getString(3));
	        dto.setMemPref(cursor.getString(4));
	        dto.setMemEmail(cursor.getString(5));
	        dto.setMemTel(cursor.getString(6));
	        dto.setMemLevel(cursor.getString(7));
	        dto.setMemLatitude(cursor.getString(8));
	        dto.setMemLongitude(cursor.getString(9));
        }
        cursor.close();
        return dto;
    }
    /* *********************************************
     *@wɂ
     ************************************************/
    public ArrayList<MemberDTO> selectSome(String terms){
    	ArrayList<MemberDTO> list=new ArrayList<MemberDTO>();
    	String[] select={"memNo","memName","memGender",
    			"memBirthday","memPref","memEmail","memTel",
    			"memLevel","memLatitude","memLongitude"};
    	String where=terms;
    	String[] whereArgs=null;
    	String groupBy=null;
    	String having=null;
    	String orderBy="memNo asc";
        Cursor cursor=db.query(DB_TABLE,select,where,whereArgs,groupBy,having,orderBy);
        while(cursor.moveToNext()){
        	MemberDTO dto=new MemberDTO();
	        dto.setMemNo(cursor.getString(0));
	        dto.setMemName(cursor.getString(1));
	        dto.setMemGender(cursor.getString(2));
	        dto.setMemBirthday(cursor.getString(3));
	        dto.setMemPref(cursor.getString(4));
	        dto.setMemEmail(cursor.getString(5));
	        dto.setMemTel(cursor.getString(6));
	        dto.setMemLevel(cursor.getString(7));
	        dto.setMemLatitude(cursor.getString(8));
	        dto.setMemLongitude(cursor.getString(9));
	        list.add(dto);
        }
        cursor.close();
    	return list;
    }
    /* *********************************************
     *@폜
     ************************************************/
    public int delete(String key){
    	String where="memNo='"+key+"'";
    	return db.delete(DB_TABLE,where,null);
    }
    /* *********************************************
     *@S폜
     ************************************************/
    public int deleteAll(){    	
    	return db.delete(DB_TABLE,null,null);
    }
    /* *********************************************
     *@ǉ
     ************************************************/
    public int insert(MemberDTO dto){
    	MemberDTO dtoEx=this.selectOne(dto.getMemNo());
    	if(!dtoEx.getMemNo().equals(""))return -1;
    	ContentValues values=new ContentValues();    	
        values.put("memNo",dto.getMemNo());
        values.put("memName",dto.getMemName());        
        values.put("memGender",dto.getMemGender());
        values.put("memBirthday",dto.getMemBirthday());
        values.put("memPref",dto.getMemPref());        
        values.put("memEmail",dto.getMemEmail());
        values.put("memTel",dto.getMemTel());
        values.put("memLevel",dto.getMemLevel());
        values.put("memLatitude",dto.getMemLatitude());
        values.put("memLongitude",dto.getMemLongitude());
        int ret=(int)db.insert(DB_TABLE,null,values);
        return ret;
    }
    /* *********************************************
     *@XV
     ************************************************/
    public int update(MemberDTO dto){
    	String where="memNo="+dto.getMemNo();
    	String[] whereArgs=null;
        ContentValues values=new ContentValues();
        values.put("memName",dto.getMemName());        
        values.put("memGender",dto.getMemGender());
        values.put("memBirthday",dto.getMemBirthday());
        values.put("memPref",dto.getMemPref());        
        values.put("memEmail",dto.getMemEmail());
        values.put("memTel",dto.getMemTel());
        values.put("memLevel",dto.getMemLevel());
        values.put("memLatitude",dto.getMemLatitude());
        values.put("memLongitude",dto.getMemLongitude());
        return db.update(DB_TABLE,values,where,whereArgs);
    }
	public int insertSome(ArrayList<MemberDTO> list) {
		// TODO ꂽ\bhEX^u
		return 0;
	} 
}
