package jp.gihyo.mitoma.careMember.model;
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;

import jp.gihyo.mitoma.careMember.R;

import org.xmlpull.v1.XmlPullParser;
import android.content.Context;
import android.util.Log;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class MemberResDAO implements MemberDAOInterface{
	private final static String TAG="MemberResDAO";
	private String resource;
	private String fileName;
	private String code;
	private Context context;
	/* *********************************************
     *@RXgN^
     ************************************************/
    public MemberResDAO(Context context,String strage,String fileName,String code){
    	this.context=context;
    	this.resource=strage;
    	this.fileName=fileName;
    	this.code=code;
    }
    /* *********************************************
     *@\[Xt@C̓ǂݍ
     ************************************************/
    public ArrayList<MemberDTO> selectSome(String terms){
    	if(this.resource.equals("xml"))return selectXml();
    	if(this.resource.equals("raw"))return selectRaw();
    	return null;
    }
    /* *********************************************
     *@XML\[X̓ǂݍ
     ************************************************/
    private ArrayList<MemberDTO> selectXml(){
    	String tagName,attName,attValue;
    	ArrayList<MemberDTO> list=new ArrayList<MemberDTO>();
    	MemberDTO dto=new MemberDTO();
    	int flag=0;
    	XmlPullParser parser=this.context.getResources()
    						.getXml(R.xml.member);
    	try {
	        while(parser.next()!=XmlPullParser.END_DOCUMENT){
	        	tagName=parser.getName();
	        	if(tagName!=null && tagName.equals(this.fileName)){
	        		for(int i=0;i<parser.getAttributeCount();i++){
	        			attName=parser.getAttributeName(i);
	        			attValue=parser.getAttributeValue(i);
	        			if(attName!=null && attValue!=null){
		        			if(attName.equals("no"))dto.setMemNo(attValue);
		        			if(attName.equals("name"))dto.setMemName(attValue);
		        			if(attName.equals("gender"))dto.setMemGender(attValue);
		        			if(attName.equals("birthday"))dto.setMemBirthday(attValue);
		        			if(attName.equals("pref"))dto.setMemPref(attValue);
		        			if(attName.equals("email"))dto.setMemEmail(attValue);
		        			if(attName.equals("tel"))dto.setMemTel(attValue);
		        			if(attName.equals("level"))dto.setMemLevel(attValue);
		        			flag++;
	        			}	        			
				    }
			        if(flag>0){
			        	list.add(dto);
			        	dto=new MemberDTO();
			        	flag=0;
			        }
	        	}      	
	        }	                
    	}catch(Exception e){Log.e(TAG,e.getMessage());list=null;}
    	return list;
    }
    /* *********************************************
     *@RAW\[X̓ǂݍ
     ************************************************/
    private ArrayList<MemberDTO> selectRaw(){
    	String buf;    	
    	ArrayList<MemberDTO> list=new ArrayList<MemberDTO>();
    	InputStream is;
    	BufferedReader br=null;
    	boolean eof=false;
    	try {
    		is=this.context.getResources().openRawResource(R.raw.member);
    		br=new BufferedReader(new InputStreamReader(is,this.code));
	        while(!eof){
	        	buf=br.readLine();
	        	if(buf!=null){
	        		String[] item=buf.split(",");
	        		MemberDTO dto=new MemberDTO();
			        dto.setMemNo(item[0]);
			        dto.setMemName(item[1]);
			        dto.setMemGender(item[2]);
			        dto.setMemBirthday(item[3]);
			        dto.setMemPref(item[4]);
			        dto.setMemEmail(item[5]);
			        dto.setMemTel(item[6]);
			        dto.setMemLevel(item[7]);
			        list.add(dto);
	        	}else eof=true;			      
	        }	                
    	}catch(Exception e){
    		Log.e(TAG,e.getMessage());
    		list=null;
    	}
    	return list;
    }     
    public MemberDTO selectOne(String key){
    	//
        return null;
    }
    public int delete(String key){
    	//
    	return -1;
    }    
    public int insert(MemberDTO dto){
    	//
    	return -1;
    }
    public int update(MemberDTO dto){
    	//
		return -1;
    }
    public int deleteAll(){
    	return -1;
    }
	public int insertSome(ArrayList<MemberDTO> list) {
		// TODO ꂽ\bhEX^u
		return 0;
	}
}
