package jp.gihyo.mitoma.careMember;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import jp.gihyo.mitoma.careMember.R;
import jp.gihyo.mitoma.careMember.model.MemberBean;
import jp.gihyo.mitoma.careMember.model.MemberDTO;
import jp.gihyo.mitoma.careMember.model.MemberList;
import jp.gihyo.mitoma.careMember.model.MemberMainte;
import android.app.Activity;
import android.app.ActivityManager;
import android.app.AlertDialog;
import android.content.ComponentName;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.ServiceConnection;
import android.net.Uri;
import android.os.Bundle;
import android.os.IBinder;
import android.os.RemoteException;
import android.text.format.DateFormat;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.GestureDetector;
import android.view.GestureDetector.OnGestureListener;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class MemberControl extends Activity implements OnGestureListener{
	private static final String tag = "MemberControl";
	private static final String serviceTag = "jp.gihyo.mitoma.careMember.service.MemberService";
    private static final int SHOW_LIST = 0;
    private boolean alertRes=false;
	private MemberView view;
	private MemberBean memberBean;
    private int status;
	private MemberBindService bindInf;
	private GestureDetector detector;
	private MemberList memList;
	private ServiceConnection cnn=new ServiceConnection(){
		public void onServiceConnected(ComponentName name, IBinder bind) {
			bindInf=MemberBindService.Stub.asInterface(bind);
		}
		public void onServiceDisconnected(ComponentName arg0) {
			bindInf=null;
		}		
	};
    @Override
    public void onCreate(Bundle bundle) {
        super.onCreate(bundle);
        this.view=new MemberView(this);
        this.view.setContextMenu();
        this.memberBean=new MemberBean(this);
        this.detector=new GestureDetector(this,this);
        this.memList=new MemberList(this);
  }
    @Override
    public void onResume() {
        super.onResume();
		if(PreferencesCont.isRemote(this)){
			Intent intent=new Intent();
			intent.setAction("jp.gihyo.mitoma.careMember.BIND");
        	bindService(intent,cnn,Context.BIND_AUTO_CREATE);
		}
    }
    @Override
    public void onPause() {
        super.onPause();
        if(PreferencesCont.isRemote(this)){
        	ActivityManager am=(ActivityManager)getSystemService(ACTIVITY_SERVICE);
            List<ActivityManager.RunningServiceInfo> serviceInfos=
                am.getRunningServices(Integer.MAX_VALUE);
            int i;
            for (i=0;i<serviceInfos.size();i++) {
                if (serviceInfos.get(i).service.getClassName().equals(serviceTag)) {                	
                    break;
                }
            }
            if(i<serviceInfos.size())unbindService(cnn);
		}
    }
    @Override   
    public void onSaveInstanceState(Bundle bundle) {
        super.onSaveInstanceState(bundle);
        bundle.putString("memNo", view.getMemNo());
        bundle.putString("memName", view.getMemName());
        bundle.putString("memGender", view.getMemGender());
        bundle.putString("memBirthday", view.getMemBirthday());
        bundle.putString("memPref", view.getMemPref());
        bundle.putString("memEmail", view.getMemEmail());
        bundle.putString("memTel", view.getMemTel());
        bundle.putString("memLevel", view.getMemLevel());
  }
    @Override
    public void onRestoreInstanceState(Bundle bundle) {
        super.onRestoreInstanceState(bundle);
//        Toast.makeText(this, "onRestorePoint",Toast.LENGTH_SHORT).show();
        view.setMemNo(bundle.getString("memNo"));
        view.setMemName(bundle.getString("memName"));
        view.setMemGender(bundle.getString("memGender"));
        view.setMemBirthday(bundle.getString("memBirthday"));
        view.setMemPref(bundle.getString("memPref"));
        view.setMemEmail(bundle.getString("memEmail"));
        view.setMemTel(bundle.getString("memTel"));
        view.setMemLevel(bundle.getString("memLevel"));
   }  
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
	  	super.onCreateOptionsMenu(menu);
	  	MenuInflater inflater = getMenuInflater();
	  	inflater.inflate(R.menu.main_first, menu);
	  	this.status=1;
	  	return true;
	}
	@Override
	public boolean onPrepareOptionsMenu(Menu menu) {
	  	super.onPrepareOptionsMenu(menu);
	  	if(status==2){
	  		menu.clear();
	  		MenuInflater inflater = getMenuInflater();
	  		inflater.inflate(R.menu.main_second, menu);
	  	}
	  	this.status+=1;
	  	return true;
	}
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
	  	super.onOptionsItemSelected(item);
	  	Intent intent;
	  	DialogInterface.OnClickListener buttonListener;
	  	AlertDialog.Builder ad;
	  	switch (item.getItemId()){
	  	case R.id.optMenu_preferences:
	  		intent = new Intent(this, jp.gihyo.mitoma.careMember.PreferencesCont.class);
			startActivity(intent);
	  		break;
		case R.id.optMenu_memlist:
	  		intent = new Intent(this, jp.gihyo.mitoma.careMember.MemberListCont.class);
	  		intent.putExtra("retCode", 1);
	  		startActivityForResult(intent,SHOW_LIST);
	  		break;
		case R.id.optMenu_dbinit:
			buttonListener=
			new DialogInterface.OnClickListener(){
				public void onClick(DialogInterface dialog, int which) {
					if(which==DialogInterface.BUTTON_POSITIVE){
						MemberMainte memberMainte=new MemberMainte(MemberControl.this);			
						int ret=memberMainte.dbClear();
						if(ret<0)showDialog(MemberControl.this,"f[^x[X","Ɏs܂B");
						else showDialog(MemberControl.this,"f[^x[X","܂B");
					}					
				}   		
			};
	        ad=new AlertDialog.Builder(this);
	        ad.setTitle("f[^x[X");
	        ad.setMessage("sĂł");
	        ad.setPositiveButton("OK",buttonListener);
	        ad.setNegativeButton("CANCEL",buttonListener);
	        ad.show();			
			break;
		case R.id.optMenu_dbsave:			
			buttonListener=
			new DialogInterface.OnClickListener(){
				public void onClick(DialogInterface dialog, int which) {
					if(which==DialogInterface.BUTTON_POSITIVE){
						MemberMainte memberMainte=new MemberMainte(MemberControl.this);			
						int ret=memberMainte.saveToFile();
						if(ret<0)showDialog(MemberControl.this,"f[^x[Xޔ","ޔɎs܂B");
						else showDialog(MemberControl.this,"f[^x[Xޔ","ޔ܂B");
					}					
				}   		
			};
	        ad=new AlertDialog.Builder(this);
	        ad.setTitle("f[^x[Xޔ");
	        ad.setMessage("f[^x[XޔsĂł");
	        ad.setPositiveButton("OK",buttonListener);
	        ad.setNegativeButton("CANCEL",buttonListener);
	        ad.show();			
			break;
		case R.id.optMenu_dbrestore:
			buttonListener=
			new DialogInterface.OnClickListener(){
				public void onClick(DialogInterface dialog, int which) {
					if(which==DialogInterface.BUTTON_POSITIVE){
						MemberMainte memberMainte=new MemberMainte(MemberControl.this);			
						int ret=memberMainte.restoreFromFile();
						if(ret<0)showDialog(MemberControl.this,"f[^x[X","Ɏs܂B");
						else showDialog(MemberControl.this,"f[^x[X","܂B");
					}					
				}   		
			};
	        ad=new AlertDialog.Builder(this);
	        ad.setTitle("f[^x[X");
	        ad.setMessage("f[^x[XsĂł");
	        ad.setPositiveButton("OK",buttonListener);
	        ad.setNegativeButton("CANCEL",buttonListener);
	        ad.show();			
			break;
	  	case R.id.optMenu_close:
	  		finish();
	  		break;
	  	}	  	
	  	return true;
	}
	@Override
	public void onCreateContextMenu(ContextMenu menu,View v,ContextMenuInfo info) {
	  	super.onCreateContextMenu(menu,v,info);
	  	MenuInflater inflater = getMenuInflater();
	  	inflater.inflate(R.menu.context, menu);
	}
	@Override
	public boolean onContextItemSelected(MenuItem item) {
	  	super.onContextItemSelected(item); 	
	  	Calendar now = Calendar.getInstance();
	  	String nowTime=(String) DateFormat.format("kk:mm",now);
        Intent intent=new Intent();
        intent.putExtra("time",nowTime);
        if(PreferencesCont.isRemote(this)){
            intent.setAction("jp.gihyo.mitoma.careMember.BIND");
        	bindService(intent,cnn,Context.BIND_AUTO_CREATE);

            if(this.bindInf!=null){
            	try {
    				if(!bindInf.isWebStatus()){
    					showDialog(this,"Caution!","T[oƘAł܂");
    					unbindService(cnn);
    					return true;
    				}
    			} catch (RemoteException e) {  			}        	
            }
            unbindService(cnn);
        }        
	  	switch (item.getItemId()){
	  	case R.id.contMenu_regist:
	  		//o^
	  		this.memberBean.setMemNo(view.getMemNo());
	  		this.memberBean.setMemName(view.getMemName());
	  		this.memberBean.setMemGender(view.getMemGender());
	  		this.memberBean.setMemBirthday(view.getMemBirthday());
	  		this.memberBean.setMemPref(view.getMemPref());
	  		this.memberBean.setMemEmail(view.getMemEmail());
	  		this.memberBean.setMemTel(view.getMemTel());
	  		this.memberBean.setMemLevel(view.getMemLevel());
	  		if(this.memberBean.memRegist()==-1)showDialog(this,"o^","łɓo^ς݂ł");
	  		else {
	  			//[g^pT[oM
	  			if(PreferencesCont.isRemote(this)){
	  				MemberDTO memDTO=new MemberDTO();
	  				memDTO.setMemNo(view.getMemNo());
	  		  		memDTO.setMemName(view.getMemName());
	  		  		memDTO.setMemGender(view.getMemGender());
	  		  		memDTO.setMemBirthday(view.getMemBirthday());
	  		  		memDTO.setMemPref(view.getMemPref());
	  		  		memDTO.setMemEmail(view.getMemEmail());
	  		  		memDTO.setMemTel(view.getMemTel());
	  		  		memDTO.setMemLevel(view.getMemLevel());
	  		  		intent.putExtra("memberDTO", memDTO);	  		  		
	  		  		intent.putExtra("procType","INSERT");
	  		  		intent.setAction("jp.gihyo.mitoma.careMember.INSERT");
  		  			startService(intent);
	  			}
	  			showDialog(this,"o^","o^܂");
	  		}
	  		break;
	  	case R.id.contMenu_inquiry:
//	  		Toast.makeText(this, "Ɖ",Toast.LENGTH_SHORT).show();
	  		//Ɖ
	  		if(memberBean.memInquiry(view.getMemNo())==0)showDialog(this,"Ɖ","o^ł");
	  		else{
		  		this.view.setMemNo(memberBean.getMemNo());
	        	this.view.setMemName(memberBean.getMemName());
	        	this.view.setMemGender(memberBean.getMemGender());
	        	this.view.setMemBirthday(memberBean.getMemBirthday());
	        	this.view.setMemPref(memberBean.getMemPref());
	        	this.view.setMemEmail(memberBean.getMemEmail());
	        	this.view.setMemTel(memberBean.getMemTel());
	        	this.view.setMemLevel(memberBean.getMemLevel());
	  		}
	  		break;
	  	case R.id.contMenu_delete:  		
	  		//폜
	  		this.memberBean.setMemNo(view.getMemNo());
	  		if(memberBean.memDelete()==0)showDialog(this,"폜","o^ł");
	  		else {
	  			//[g^pT[oM
	  			if(PreferencesCont.isRemote(this)){
	  				MemberDTO memDTO=new MemberDTO();
	  				memDTO.setMemNo(view.getMemNo());
	  				intent.putExtra("memberDTO", memDTO);
	  				intent.putExtra("procType","DELETE");
	  		  		intent.setAction("jp.gihyo.mitoma.careMember.DELETE");
	  		  		startService(intent);
	  			}
	  			showDialog(this,"폜",view.getMemNo()+"폜܂");
	  			this.view.setMemNo("");
	        	this.view.setMemName("");
	        	this.view.setMemGender("");
	        	this.view.setMemBirthday("");
	        	this.view.setMemPref("");
	        	this.view.setMemEmail("");
	        	this.view.setMemTel("");
	        	this.view.setMemLevel("");
	  		}	  		
	  		break;
	  	case R.id.contMenu_update:
	  		//XV
	  		this.memberBean.setMemNo(view.getMemNo());
	  		this.memberBean.setMemName(view.getMemName());
	  		this.memberBean.setMemGender(view.getMemGender());
	  		this.memberBean.setMemBirthday(view.getMemBirthday());
	  		this.memberBean.setMemPref(view.getMemPref());
	  		this.memberBean.setMemEmail(view.getMemEmail());
	  		this.memberBean.setMemTel(view.getMemTel());
	  		this.memberBean.setMemLevel(view.getMemLevel());
	  		if(memberBean.memUpdate()==0)showDialog(this,"XV","o^ł");
	  		else{
	  			//[g^pT[oM
	  			if(PreferencesCont.isRemote(this)){
	  				MemberDTO memDTO=new MemberDTO();
	  				memDTO.setMemNo(view.getMemNo());
	  		  		memDTO.setMemName(view.getMemName());
	  		  		memDTO.setMemGender(view.getMemGender());
	  		  		memDTO.setMemBirthday(view.getMemBirthday());
	  		  		memDTO.setMemPref(view.getMemPref());
	  		  		memDTO.setMemEmail(view.getMemEmail());
	  		  		memDTO.setMemTel(view.getMemTel());
	  		  		memDTO.setMemLevel(view.getMemLevel());
	  		  		intent.putExtra("memberDTO", memDTO);
	  		  		intent.putExtra("procType","UPDATE");
	  		  		intent.setAction("jp.gihyo.mitoma.careMember.UPDATE");
	  		  		startService(intent);
	  			}
	  			showDialog(this,"XV",this.memberBean.getMemNo()+"XV܂");
	  		}
	  		break;
	  	case R.id.contMenu_clear:
	  		//ʃNA
	  		this.view.setMemNo("");
        	this.view.setMemName("");
        	this.view.setMemGender("");
        	this.view.setMemBirthday("");
        	this.view.setMemPref("");
        	this.view.setMemEmail("");
        	this.view.setMemTel("");
        	this.view.setMemLevel("");
	  		break;
	  		
	  	case R.id.contMenu_bind:	  		
	  		if(PreferencesCont.isRemote(this)){
		  		intent.setAction("jp.gihyo.mitoma.careMember.BIND");
	        	bindService(intent,cnn,Context.BIND_AUTO_CREATE);        	
		  		ArrayList<String> queue=null;
		  	
		  		bindService(intent,cnn,Context.BIND_AUTO_CREATE);  

	            if(this.bindInf!=null){
	            	try {queue=(ArrayList<String>)this.bindInf.getQueue();	    				
	    			} catch (RemoteException e) {  			} 
	            	if(queue!=null){
			        	final String[] input=new String[queue.size()];        	
						for(int i=0;i<queue.size();i++)input[i]=queue.get(i);
						new AlertDialog.Builder(this)
						.setIcon(R.drawable.icon)
						.setTitle("Mꗗ")
						.setItems(input, null)
						.show();
	            	}else{
	            		showDialog(this,"Notification","M̃f[^͂܂");
	            	}
	            }else{
	            	showDialog(this,"Caution!","T[oƘAł܂");
	            }
	            unbindService(cnn);
	  		}else{
	  			showDialog(this,"Attention!","݃T[oƖڑŉ^pł");
	  		}
        }
	  	return true;
	}
	@Override
	protected void onActivityResult(int reqCode,int resultCode,Intent intent){
		if(reqCode==SHOW_LIST){
			if(resultCode==RESULT_OK){
		        MemberDTO memDto=(MemberDTO) intent.getSerializableExtra("memberDTO");
		        if(memDto!=null){
		        	this.view.setMemNo(memDto.getMemNo());
		        	this.view.setMemName(memDto.getMemName());
		        	this.view.setMemGender(memDto.getMemGender());
		        	this.view.setMemBirthday(memDto.getMemBirthday());
		        	this.view.setMemPref(memDto.getMemPref());
		        	this.view.setMemEmail(memDto.getMemEmail());
		        	this.view.setMemTel(memDto.getMemTel());
		        	this.view.setMemLevel(memDto.getMemLevel());
		        }
		     }
		}		
	}
    public void onTouch(View v) {
    	view.dialogInput(v);    	
    }
    public void onTelephone(View v) {
    	Intent intent=new Intent();
    	intent.setAction(Intent.ACTION_DIAL);
    	intent.setData(Uri.parse("tel:"+view.getMemTel()));
    	startActivity(intent);
    }   
    private static void showDialog(Context context,String title,String text) {
        AlertDialog.Builder ad=new AlertDialog.Builder(context);
        ad.setTitle(title);
        ad.setMessage(text);
        ad.setPositiveButton("OK",null);
        ad.show();
    }
    
    @Override
    public boolean onTouchEvent(MotionEvent event){
//    	Log.v("GestureTester","TouchEvent W(X:"+event.getX()+",Y:"+event.getY()+")");
    	detector.onTouchEvent(event);
      	super.onTouchEvent(event);
    	return true;
    }
    public boolean onDown(MotionEvent arg0) {
		// TODO ꂽ\bhEX^u
		return false;
	}
	public boolean onFling(MotionEvent event0, MotionEvent event1, float xSpeed,float ySpeed) {
		ArrayList<MemberDTO> list=this.memList.getList();
		MemberDTO memDto=list.get(0);
		String memNo=view.getMemNo();
		if(xSpeed<-800){
			for(int i=0;i<list.size();i++){
				memDto=list.get(i);
				if(memDto.getMemNo().compareTo(memNo)>0)break;
			}
		}
		if(xSpeed>800){
			for(int i=list.size()-1;i>=0;i--){
				memDto=list.get(i);
				if(memDto.getMemNo().compareTo(memNo)<0)break;
			}
		}
		this.view.setMemNo(memDto.getMemNo());
    	this.view.setMemName(memDto.getMemName());
    	this.view.setMemGender(memDto.getMemGender());
    	this.view.setMemBirthday(memDto.getMemBirthday());
    	this.view.setMemPref(memDto.getMemPref());
    	this.view.setMemEmail(memDto.getMemEmail());
    	this.view.setMemTel(memDto.getMemTel());
    	this.view.setMemLevel(memDto.getMemLevel());
		return true;
	}
	public void onLongPress(MotionEvent e) {
		// TODO ꂽ\bhEX^u
		
	}
	public boolean onScroll(MotionEvent e1, MotionEvent e2, float distanceX,
			float distanceY) {
		// TODO ꂽ\bhEX^u
		return false;
	}
	public void onShowPress(MotionEvent e) {
		// TODO ꂽ\bhEX^u
		
	}
	public boolean onSingleTapUp(MotionEvent e) {
		// TODO ꂽ\bhEX^u
		return false;
	}
    
}