package jp.gihyo.mitoma.carePlan;
import java.util.ArrayList;
import java.util.Calendar;
import jp.gihyo.mitoma.carePlan.model.CareBean;
import jp.gihyo.mitoma.carePlan.model.CareDTO;
import jp.gihyo.mitoma.carePlan.model.CareMainte;
import jp.gihyo.mitoma.carePlan.view.CarePlanView;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.text.format.DateFormat;
import android.view.GestureDetector;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.GestureDetector.OnGestureListener;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class CarePlanControl extends Activity  implements OnGestureListener{
	private CarePlanView planView;
	private CareBean careBean;
	private CareMainte careMainte;
	private String date;
	private String memNo;
	private String memName;
	private int lineNo;
	private GestureDetector detector;
	private boolean updateFlg;
	
     @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //̓tҏW
        Calendar now = Calendar.getInstance();
     	this.date=(String) DateFormat.format("yyyy/MM/dd",now);
     	
     	//Jڌ瑗ꂽIntent̉ԍƉo
        Intent intent=getIntent();
        this.memNo=intent.getStringExtra("memNo");
        this.memName=intent.getStringExtra("memName");
        if(this.memNo==null)this.memNo="000000";
        if(this.memName==null)this.memName="ݒ";

        Intent newIntent=new Intent("jp.gihyo.mitoma.carePlan.CARE_PLAN_CHECK");
        startService(newIntent);
        this.detector=new GestureDetector(this,this);
        this.updateFlg=false;
     }
     @Override
     public void onResume() {
         super.onResume();
         //r[𐶐ԍƉ\
         planView=new CarePlanView(this);
         planView.setMemNo(this.memNo);
         planView.setMemName(this.memName);
         
         //w̖{̃r[𐶐
         careBean=new CareBean(this,this.memNo,this.date);
         
         //v̐擪\
         this.lineNo=0;
         if(careBean.isCareExist())
        	 this.dispDTO(careBean.getCareMatter(),this.lineNo);
       //CateMainte𐶐
         careMainte=new CareMainte(this);
      }
     @Override
     public void onPause() {
         super.onPause();
         if(!this.updateFlg)return;
		/* ***********************************************
 		 * cao
 		 **************************************************/
 		/* ***********************************************
 		 * Ƀvԍ_ũ`FbN
 		 **************************************************/
 		for(int i=0;i<careBean.getCareMatter().size();i++){
 			CareDTO careDto=careBean.getCareMatter().get(i);
 			careDto.setMemNo(this.memNo);
 			careDto.setMemName(this.memName);
 			careDto.setDate(this.date);
 		}
 		careBean.careRegist();
     }
     /* *********************************************
      * IvVj[̍쐬
      ************************************************/
     @Override
 	public boolean onCreateOptionsMenu(android.view.Menu menu) {
 	  	super.onCreateOptionsMenu(menu);
 	  	MenuInflater inflater = getMenuInflater();
 	  	inflater.inflate(R.menu.main, menu);
 	  	return true;
 	}
     /* *********************************************
      * IvVj[Cxg
      ************************************************/ 
   	@Override
   	public boolean onOptionsItemSelected(MenuItem item) {
   		
   	  	super.onOptionsItemSelected(item);
   	  	switch (item.getItemId()){
   	  	//v揉
   		case R.id.optmenu_planinit:
    		//v̐`Ǎ݁CcareBeanɃZbg
    		careBean.setCareMatter(careMainte.getBasicPlan());
    		//擪\
    		this.lineNo=0;
    		//v̐擪\
            this.lineNo=0;
            this.dispDTO(careBean.getCareMatter(),this.lineNo);
    		//T[rX̌Ăяo
    		Intent intent=new Intent("jp.gihyo.mitoma.carePlan.INSERT");    			  		  		
		  	intent.putExtra("procType","INSERT");
    		for(int i=0;i<careBean.getCareMatter().size();i++){
    			intent.putExtra("careDTO", careBean.getCareMatter().get(i));
    			startService(intent);
    		}
    		this.updateFlg=true;
    		
    		break;
    	//ca
   	  	case R.id.optmenu_dbinit:
   	  		careMainte.dbClear();
   	  		this.updateFlg=false;
   	  		//w̖{̃r[𐶐
            careBean=new CareBean(this,this.memNo,this.date);
            this.lineNo=0;
            this.dispDTO(careBean.getCareMatter(),this.lineNo);
   	  		break;
   	  	//I
   	  	case R.id.optmenu_close:
   	  		finish();
   	  		break;
   	  	}	  	
   	  	return true;
   	}
    /* *********************************************
     * \莞&{^b`Cxg
     ************************************************/
    public void onTouch(View v) {
       planView.dialogInput(v);
    }
    /* *********************************************
     * {^^b`Cxg
     ************************************************/
    public void onClick(View v) {
    	CareDTO careDto;
    	Intent intent = new Intent();
    	switch(v.getId()){
    	//ǉ
    	case R.id.btn4:    		
    		/* ***********************************************
    		 * Ƀvԍ_ũ`FbN
    		 **************************************************/
    		/* ***********************************************
    		 * eڂ̃`FbN
    		 **************************************************/
    		/* ***********************************************
    		 * ɒǉmF̃_CAO\鏈
    		 **************************************************/
    		careDto=new CareDTO();
    		//ʃf[^̎荞
    		careDto.setCareCode(planView.getCareCode());
    		careDto.setCareName(planView.getCareName());
    		careDto.setPlanNo(planView.getPlanNo());
    		careDto.setPredTime(planView.getPredTime());
    		careDto.setImplTime(planView.getImplTime());
    		careDto.setResult(planView.getResult());
    		//ArrayList֒ǉ
    		careBean.getCareMatter().add(careDto);
    		//ArrayListvԍɕׂ
    		arraySort(careBean.getCareMatter());
    		//Vsԍ߂    		
    		for(this.lineNo=0;this.lineNo<careBean.getCareMatter().size();this.lineNo++){
    			if(careBean.getCareMatter().get(this.lineNo).getPlanNo().equals(planView.getPlanNo()))break;    			
    		}
    		if(this.lineNo>=careBean.getCareMatter().size())this.lineNo=careBean.getCareMatter().size()-1;
    		//T[rX̌Ăяo
    		intent.setAction("jp.gihyo.mitoma.carePlan.INSERT");
    		intent.putExtra("careDTO", careDto);	  		  		
		  	intent.putExtra("procType","INSERT");		  	
	  		startService(intent);
	  		this.updateFlg=true;
    		break;
    	//폜	
    	case R.id.btn6:
    		if(careBean.getCareMatter().size()<1)break;
    		/* ***********************************************
    		 * ɍ폜mF̃_CAO\鏈
    		 **************************************************/
    		careDto=careBean.getCareMatter().get(this.lineNo);
    		careBean.getCareMatter().remove(this.lineNo);    		
    		if(this.lineNo>=careBean.getCareMatter().size())this.lineNo=careBean.getCareMatter().size()-1;    		
    		//ĕ\
    		this.dispDTO(careBean.getCareMatter(),this.lineNo);
    		//T[rX̌Ăяo
    		intent.setAction("jp.gihyo.mitoma.carePlan.DELETE");
    		intent.putExtra("careDTO", careDto);	  		  		
		  	intent.putExtra("procType","DELETE");		  	
	  		startService(intent);
	  		this.updateFlg=true;
    		break;
    	}
    }
    /* *********************************************
     * ꗗ̖߂̏
     ************************************************/
	@Override
	protected void onActivityResult(int reqCode,int resultCode,Intent intent){
		if(resultCode==RESULT_OK){
			try{
				this.memNo=intent.getStringExtra("memNo");
				this.memName=intent.getStringExtra("memName");
		         planView.setMemNo(this.memNo);
		         planView.setMemName(this.memName);
		         
		         //̉vƉ
		         careBean.careInquiry(this.memNo,this.date);
		         
		         //v̐擪\
		         this.lineNo=0;
		         if(careBean.isCareExist()&& careBean.getCareMatter()!=null){
		        	 this.dispDTO(careBean.getCareMatter(),this.lineNo);
		         }         

			}catch(Exception e){
				
			}
		 }
	}

    /* *********************************************
     * WFX`Cxg
     ************************************************/
    @Override
    public boolean onTouchEvent(MotionEvent event){
    	detector.onTouchEvent(event);
      	super.onTouchEvent(event);
    	return true;
    }
    //tbN
	public boolean onFling(MotionEvent event0, MotionEvent event1, float xSpeed,
			float ySpeed) {
		CareDTO careDto;
		if(xSpeed<-800 && careBean.getCareMatter().size()>0){
			careDto=careBean.getCareMatter().get(this.lineNo);
			//XV󋵂̃`FbN
			updateCheck(careDto);
    		//쎖ړ
    		if(++this.lineNo>=careBean.getCareMatter().size())
    			this.lineNo=careBean.getCareMatter().size()-1;
    		this.dispDTO(careBean.getCareMatter(),this.lineNo);
		}
		if(xSpeed>800 && careBean.getCareMatter().size()>0){
			careDto=careBean.getCareMatter().get(this.lineNo);
			//XV󋵂̃`FbN
			updateCheck(careDto);
    		//쎖Oړ
			if(--this.lineNo<0)
    			this.lineNo=0;
    		this.dispDTO(careBean.getCareMatter(),this.lineNo);
		}
		return true;
	}
	//OvX
	public void onLongPress(MotionEvent e) {
		Intent intent=new Intent("jp.gihyo.mitoma.careMember.LIST_VIEW");
  		startActivityForResult(intent,0);
	}
	//gpWFX`[
	public boolean onDown(MotionEvent e) {return false;}
	public boolean onScroll(MotionEvent e1, MotionEvent e2, float distanceX,
			float distanceY) {return false;}
	public void onShowPress(MotionEvent e) {}
	public boolean onSingleTapUp(MotionEvent e) {return false;} 
	
	/* *********************************************
     * eύX̏
     ************************************************/
	private boolean updateCheck(CareDTO dto){
		boolean flg=false;		
		if(!planView.getCareCode().equals(dto.getCareCode()))flg=true;
		if(!planView.getPlanNo().equals(dto.getPlanNo()))flg=true;
		if(!planView.getPredTime().equals(dto.getPredTime()))flg=true;
		if(!planView.getImplTime().equals(dto.getImplTime()))flg=true;
		if(!planView.getResult().equals(dto.getResult()))flg=true;
		if(flg){
		/* ***********************************************
		 * ύX̂ƂړỎ쎖r[Ɏ荞
		 **************************************************/    		
    		dto.setCareCode(planView.getCareCode());
    		dto.setCareName(planView.getCareName());
    		dto.setPlanNo(planView.getPlanNo());
    		dto.setPredTime(planView.getPredTime());
    		dto.setImplTime(planView.getImplTime());
    		dto.setResult(planView.getResult());
    		arraySort(careBean.getCareMatter());
    		Intent intent=new Intent("jp.gihyo.mitoma.carePlan.UPDATE");
    		intent.putExtra("careDTO", dto);	  		  		
		  	intent.putExtra("procType","UPDATE");		  	
	  		startService(intent);
	  		this.updateFlg=true;
		}
		return flg;
	}
    /* *********************************************
     * ArrayListwsCareDTȎSڂ܂Ƃ߂ĕ\
     ************************************************/
    private void dispDTO(ArrayList<CareDTO> list,int line){
    	if(list!=null){
	    	if(!list.isEmpty()){
	    		if(list.size()>line&&line>=0){	    	
			    	CareDTO dto=list.get(line);
			    	planView.setCareCode(dto.getCareCode());
			    	planView.setCareName(dto.getCareName());
			    	planView.setPlanNo(dto.getPlanNo());
			    	planView.setPredTime(dto.getPredTime());
			    	planView.setImplTime(dto.getImplTime());
			    	planView.setResult(dto.getResult());
	    		}
	    	}else{
	    		planView.setCareCode("");
		    	planView.setCareName("");
		    	planView.setPlanNo("");
		    	planView.setPredTime("");
		    	planView.setImplTime("");
		    	planView.setResult("");
	    	}	    	
    	}else{
    		planView.setCareCode("");
	    	planView.setCareName("");
	    	planView.setPlanNo("");
	    	planView.setPredTime("");
	    	planView.setImplTime("");
	    	planView.setResult("");
    	}
    }
    /* *********************************************
     * ArrayListvԍɕׂ
     ************************************************/
    private void arraySort(ArrayList<CareDTO> list){
    	CareDTO work;
    	for(int i=0;i<list.size()-1;i++){
    		for(int j=i+1;j<list.size();j++){
    			if(list.get(i).getPlanNo().compareToIgnoreCase(list.get(j).getPlanNo())>0){
    				work=list.get(i);
    				list.set(i, list.get(j));
    				list.set(j, work);
    			}
    		}
    	}    		
    }
}