package jp.gihyo.mitoma.careTimerV01.activity.model;

import java.util.ArrayList;

import android.content.Context;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class CareBean {
	private String memNo;
	private String memName;
	private String date;
	private ArrayList<CareDTO> careMatter;
	private String helperCode;
	private String helperName;
	private CareDAO careDAO;
	public CareBean(){
		this.memNo="";
		this.memName="";
		this.date="";
		this.careMatter=null;
		this.helperCode="";
		this.helperName="";
	}
	public CareBean(Context context){
		this();		
		this.careDAO=new CareDAO(context);
	}
	public CareBean(Context context,String memNo,String date){
		this(context);
		this.careMatter=careDAO.selectSet(memNo, date);
		this.memNo=memNo;
		if(this.careMatter.size()>=1){
			CareDTO dto=this.careMatter.get(0);
			this.memName=dto.getMemName();
			this.date=dto.getDate();
			this.helperCode=dto.getHelperCode();
			this.helperName=dto.getHelperName();
		}
	}
	public void setMemNo(String no){this.memNo=no;}
	public void setMemName(String name){this.memName=name;}
	public void setDate(String date){this.date=date;}
	public void setCareMatter(ArrayList<CareDTO> array){this.careMatter=array;}
	public void setHelperCode(String code){this.helperCode=code;}
	public void setHelperName(String name){this.helperName=name;}
	
	public String getMemNo(){return this.memNo;}
	public String getMemName(){return this.memName;}
	public String getDate(){return this.date;}
	public ArrayList<CareDTO> getCareMatter(){return this.careMatter;}
	public String getHelperCode(){return this.helperCode;}
	public String getHelperName(){return this.helperName;}
	public int careRegist(){
		careDAO.deleteSet(this.memNo, this.date);
		careDAO.insertSet(this.careMatter);
		return 0;
	}
	public int careDelete(){
		careDAO.deleteAll();
		return 0;
	}
	public int careUpdate(){		
		return careDAO.updateSet(careMatter);
	}
	public int careInquiry(String memNo,String date){
		this.careMatter=careDAO.selectSet(memNo, date);
		int ret=this.careMatter.size();
		if(ret>=1){
			CareDTO dto=this.careMatter.get(0);
			this.memNo=dto.getMemNo();
			this.memName=dto.getMemName();
			this.date=dto.getDate();
			this.helperCode=dto.getHelperCode();
			this.helperName=dto.getHelperName();
		}
    	return ret;
	}
	public int careInit(){
		this.setMemNo("201101");
    	this.setMemName("Z]Y");
    	this.setHelperCode("123456");
    	this.setHelperName("hCh");
    	ArrayList<CareDTO> careList=new ArrayList<CareDTO>();
    	CareDTO care=new CareDTO();
    	care.setCareCode("D01");
    	care.setCareName("H");
    	care.setResult("Ԍ");
    	care.setPredTime("AM 08:30");
    	care.setPlanNo("1000");
    	careList.add(care);
    	
    	care=new CareDTO();
    	care.setCareCode("M01");
    	care.setCareName("");
    	care.setResult("Ԍ");
    	care.setPredTime("AM 09:30");
    	care.setPlanNo("1010");
    	careList.add(care);
    	
    	care=new CareDTO();
    	care.setCareCode("T01");
    	care.setCareName("gC");
    	care.setResult("ނ̌");
    	care.setPredTime("AM 10:30");
    	care.setPlanNo("1020");
    	careList.add(care);
    	
    	care=new CareDTO();
    	care.setCareCode("D01");
    	care.setCareName("H");
    	care.setResult("Ԍ");
    	care.setPredTime("AM 11:30");
    	care.setPlanNo("1030");
    	careList.add(care);
    	
    	care=new CareDTO();
    	care.setCareCode("B01");
    	care.setCareName("");
    	care.setPredTime("PM 02:15");
    	care.setPlanNo("1040");
    	care.setResult("2ŉ邱");
    	careList.add(care);
    	
    	care=new CareDTO();
    	care.setCareCode("W01");
    	care.setCareName("U");
    	care.setPredTime("PM 03:30");
    	care.setPlanNo("1050");
    	care.setResult("");
    	careList.add(care);
    	
    	care=new CareDTO();
    	care.setCareCode("D01");
    	care.setCareName("H");
    	care.setResult("Ԍ");
    	care.setPredTime("PM 18:00");
    	care.setPlanNo("1060");
    	careList.add(care);
    	
    	care=new CareDTO();
    	care.setCareCode("H01");
    	care.setCareName("f");
    	care.setResult("Ԍ");
    	care.setPredTime("PM 18:00");
    	care.setPlanNo("1070");
    	careList.add(care);
    	
    	this.setCareMatter(careList);
		return 0;
	}
	
	public boolean isCareExist(){
		if(this.memNo.equals("")||this.memName.equals(""))return false;
		else if(this.careMatter==null)return true;
		else if(this.careMatter.size()<1)return true;
		else return true;
	}
}