package jp.gihyo.mitoma.careTimer.activity;

import java.util.Calendar;

import jp.gihyo.mitoma.careTimer.R;

import android.app.Activity;
import android.app.TimePickerDialog;
import android.text.format.DateFormat;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.TimePicker;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *@@@̃r[͉K̃e[}ɂĂ܂B
 *********************************************************************/
public class CarePlanView {
	private Activity act;	
	private TextView memNo;
	private TextView memName;
	private Spinner careCode;
	private TextView careName;
	private EditText planNo;
	private TextView predTime;
	private TextView implTime;
	private EditText result;
    public CarePlanView(Object obj) {    	
        act=(Activity)obj;
        act.setContentView(R.layout.care_plan); 
        memNo=(TextView)act.findViewById(R.id.memNo);
        memName=(TextView)act.findViewById(R.id.memName);
        careCode=(Spinner)act.findViewById(R.id.careCode);
        careName=(TextView)act.findViewById(R.id.careName);
        planNo=(EditText)act.findViewById(R.id.planNo);
        predTime=(TextView)act.findViewById(R.id.predTime);
        implTime=(TextView)act.findViewById(R.id.implTime);
        result=(EditText)act.findViewById(R.id.result);
        /* *********************************************
         * PAR[hIꂽƂ̏
         ************************************************/
        careCode.setOnItemSelectedListener(new OnItemSelectedListener(){
			public void onItemSelected(AdapterView<?> parent, View v,int position, long id) {
				Spinner sp=(Spinner)parent;
				//I𕶎𕪗C̕careNameɕ\
				String str1=sp.getSelectedItem().toString();
				String[] strArray=str1.split("@");
				careName.setText(strArray[2]);
			}
			public void onNothingSelected(AdapterView<?> arg0) {
				// TODO ꂽ\bh
			}        	
        });        
    }
    /* *********************************************
     * Qb^[
     ************************************************/
    public String getMemNo(){return memNo.getText().toString();}
    public String getMemName(){return memName.getText().toString();}
    public String getCareCode(){
    	//𕪗CR[hԓ
    	String[] split=careCode.getSelectedItem().toString().split("@");
    	return split[0];
    }    
    public String getCareName(){return careName.getText().toString();}
    public String getPlanNo(){return planNo.getText().toString();}
    public String getPredTime(){return predTime.getText().toString();}
    public String getImplTime(){return implTime.getText().toString();}
    public String getResult(){return result.getText().toString();}
    /* *********************************************
     * Zb^[
     ************************************************/  
    public void setMemNo(String no){memNo.setText(no);}
    public void setMemName(String name){memName.setText(name);}
    public void setCareCode(String code){careCode.setSelection(selectNo(code));}
    public void setCareName(String name){careName.setText(name);}
    public void setPlanNo(String no){planNo.setText(no);}
    public void setPredTime(String pred){predTime.setText(pred);}
    public void setImplTime(String impl){implTime.setText(impl);}
    public void setResult(String r){result.setText(r);}
    /* *********************************************
     * _CAO
     ************************************************/
    public void dialogInput(View v){
    	TimePickerDialog timeDialog;
     	
    	switch(v.getId()){
    	//\莞
    	case R.id.predTime:
    		timeDialog=new TimePickerDialog(act,new TimePickerDialog.OnTimeSetListener(){
    			public void onTimeSet(TimePicker view,int hour,int minute){
    				// ampm hh:mm`ɕҏW\
    				Calendar now = Calendar.getInstance();
    				now.set(0, 0, 0, hour, minute);
    				predTime.setText(DateFormat.format("kk:mm",now));
    			}
			},12,0,true);
    		timeDialog.setTitle("\莞");
    		timeDialog.show();
    		break;
    	//{
    	case R.id.implTime:
    		timeDialog=new TimePickerDialog(act,new TimePickerDialog.OnTimeSetListener(){
    			public void onTimeSet(TimePicker view,int hour,int minute){
    				Calendar now = Calendar.getInstance();
    				now.set(0, 0, 0, hour, minute);
    				implTime.setText(DateFormat.format("kk:mm",now));
    			}
			},12,0,true);
    		timeDialog.setTitle("{");
    		timeDialog.show();
    		break;
    	}
    }
    /* *********************************************
     * PAR[hXsi[̍sԍ\bh
     ************************************************/   
	private int selectNo(String arg){
		//\[X\zo
		String[] ddl=this.act.getResources().getStringArray(R.array.care_code_list);
		int i;
		String[] split;
		for(i=0;i<ddl.length;i++){
			split=ddl[i].split("@");
			if(split[0].equals(arg))break;
		}
		if(i>=ddl.length)i=0;
		return i;
	}
}