package jp.gihyo.mitoma.careWalkV01.model;

import java.util.ArrayList;

import android.content.Context;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class WalkBean {
	private String memNo;
	private String memName;
	private String date;
	private String planNo;
	private String time;
	private String latitude;	
	private String longitude;
	private String helperCode;
	private String helperName;
	private ArrayList<WalkDTO> locationList;
	private WalkDAOInterface walkDAO;
	public WalkBean(){
		this.memNo="";
		this.memName="";
		this.date="";
		this.planNo="";
		this.time="";
		this.latitude="";
		this.longitude="";
		this.helperCode="";
		this.helperName="";
		this.locationList=null;
	}
	public WalkBean(Context context){
		this();
		this.walkDAO=new WalkDAO(context);
	}
	public WalkBean(Context context,String memNo,String date,String planNo){
		this(context);
		this.locationList=this.walkDAO.selectSet(memNo, date,planNo);
		
	}
	public void setMemNo(String no){this.memNo=no;}
	public void setMemName(String name){this.memName=name;}
	public void setDate(String date){this.date=date;}
	public void setPlanNo(String no){this.planNo=no;}
	public void setTime(String time){this.time=time;}
	public void setLatitude(String data){this.latitude=data;}
	public void setLongitude(String data){this.longitude=data;}
	public void setHelperCode(String code){this.helperCode=code;}
	public void setHelperName(String name){this.helperName=name;}
	
	public String getMemNo(){return this.memNo;}
	public String getMemName(){return this.memName;}
	public String getDate(){return this.date;}
	public String getPlanNo(){return this.planNo;}
	public String getTime(){return this.time;}
	public String getLatitude(){return this.latitude;}
	public String getLongitude(){return this.longitude;}
	public String getHelperCode(){return this.helperCode;}
	public String getHelperName(){return this.helperName;}
	public ArrayList<WalkDTO> getLocationList(){return this.locationList;}
	
	public int walkRegist(){
		WalkDTO walkDTO=new WalkDTO();
		walkDTO.setMemNo(memNo);
		walkDTO.setMemName(memName);
		walkDTO.setDate(date);
		walkDTO.setPlanNo(planNo);
		walkDTO.setTime(time);
		walkDTO.setLatitude(latitude);
		walkDTO.setLongitude(longitude);
		walkDTO.setHelperCode(helperCode);
		walkDTO.setHelperName(helperName);
		this.walkDAO.insertOne(walkDTO);
		return 0;
	}
	public int walkDelete(String memNo,String date,String planNo){
		return this.walkDAO.deleteOne(memNo, date,planNo);
	}
	public int walkInquiry(String memNo,String date,String planNo){
    	this.locationList=this.walkDAO.selectSet(memNo, date,planNo);
    	return this.locationList.size();
	}

	public boolean isCareExist(){
		if(this.memNo.equals("")||this.memName.equals(""))return false;
		else return true;
	}
}