package jp.gihyo.android.exercise08.model;

import java.util.ArrayList;
import jp.gihyo.android.exercise.R;
import org.xmlpull.v1.XmlPullParser;
import android.content.Context;
import android.util.Log;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class CareResDAO implements CareDAOInterface{
	private final static String TAG="MemberResDAO";
	private Context context;
	private String tagName;
    public CareResDAO(Context context){
    	this.context=context;
    	this.tagName="matter";
    }    
    public ArrayList<CareDTO> selectSet(String args1,String args2){    	
    	String tagName,attName,attValue;
    	ArrayList<CareDTO> list=new ArrayList<CareDTO>();
    	CareDTO dto=new CareDTO();
    	int flag=0;
    	XmlPullParser parser=this.context.getResources()
    						.getXml(R.xml.care_matter);
    	try {
	        while(parser.next()!=XmlPullParser.END_DOCUMENT){
	        	tagName=parser.getName();
	        	if(tagName!=null && tagName.equals(this.tagName)){
	        		for(int i=0;i<parser.getAttributeCount();i++){
	        			attName=parser.getAttributeName(i);
	        			attValue=parser.getAttributeValue(i);
	        			if(attName!=null && attValue!=null){
		        			if(attName.equals("code"))dto.setCareCode(attValue);
		        			if(attName.equals("name"))dto.setCareName(attValue);
		        			if(attName.equals("plan"))dto.setPlanNo(attValue);
		        			if(attName.equals("pred"))dto.setPredTime(attValue);
		        			flag++;
	        			}	        			
				    }
			        if(flag>0){
			        	list.add(dto);
			        	dto=new CareDTO();
			        	flag=0;
			        }
	        	}      	
	        }	                
    	}catch(Exception e){Log.e(TAG,e.getMessage());list=null;}
    	return list;
    }
    public int deleteOne(String key1,String key2,String key3){
    	//NOP
        return 0;
    }
    public int deleteSet(String key1,String key2){
    	//NOP
        return 0;
    }
    public int deleteAll(){
    	//NOP
        return 0;
    }
    public int insertOne(CareDTO dto){
    	//NOP
        return 0;
    }
    public int insertSet(ArrayList<CareDTO> list){
    	//NOP
        return 0;
    }
    public int updateOne(CareDTO dto){
    	//NOP
        return 0;
    }
    public int updateSet(ArrayList<CareDTO> list){
    	//NOP
        return 0;
    }
	public ArrayList<CareDTO> selectAny(String where) {
		// NOP
		return null;
	}
}
