package jp.gihyo.android.exercise08.service;

import java.util.ArrayList;
import java.util.Calendar;
import jp.gihyo.android.exercise.R;
import jp.gihyo.android.exercise08.model.CareDAOInterface;
import jp.gihyo.android.exercise08.model.CareProvDAO;
import jp.gihyo.android.exercise08.model.CareDTO;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.os.IBinder;
import android.text.format.DateFormat;
import android.util.Log;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class CarePlanCheckService extends Service{
    private CareDAOInterface careDAO;
    @Override
    public void onCreate(){
    	Log.d("CareService", "Create now");
    	this.careDAO=new CareProvDAO(this);    	
    }
    /* *****************************************************************
     * ̉vL`FbN
     *******************************************************************/
    @Override
    public void onStart(Intent intent,int startID) {
    	Log.d("CareService", "Start now"); 
    	Calendar now = Calendar.getInstance();
     	String date=(String) DateFormat.format("yyyy/MM/dd",now);
     	String where="date='"+date+"'";
     	ArrayList<CareDTO> list=careDAO.selectAny(where);
     	if(list.size()<1){
     		//v悪ȂƂ̏(meBtBP[V̕\)
     		NotificationManager nm=(NotificationManager)getSystemService(Context.NOTIFICATION_SERVICE);
     		Notification notif=new Notification();
	  		notif.icon=R.drawable.caution;
	  		notif.defaults |=Notification.DEFAULT_SOUND;
	  		notif.flags |=Notification.FLAG_AUTO_CANCEL;
	  		notif.when=System.currentTimeMillis();
	  		Intent nextIntent=new Intent("jp.gihyo.exercise.carePlan.MAIN_VIEW");
	  		PendingIntent pi = 
		            PendingIntent.getActivity(getApplicationContext(), 0, nextIntent, 0);
	  		notif.setLatestEventInfo(getApplicationContext(), "v斢ݒ","̉v𗧂ĉ", pi);
	  		nm.notify(0, notif);
     	}
     	stopSelf();
    }    
	@Override
	public IBinder onBind(Intent intent) {
		// TODO ꂽ\bhEX^u
		return null;
	}
}
