package jp.gihyo.mitoma.intentTester;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class InentView{
	private Activity act;
	private TextView action;
	private EditText data;
	private TextView category;
	private EditText pkg;
	private EditText cls;
	private EditText type;
	private EditText extras;
	private EditText result;
	private Button button;
	//RXgN^
    public InentView(Activity obj) {
        act=obj;
        act.requestWindowFeature(Window.FEATURE_NO_TITLE);
        act.setContentView(R.layout.main);
        action=(TextView)act.findViewById(R.id.action);
        data=(EditText)act.findViewById(R.id.data);
        category=(TextView)act.findViewById(R.id.category);
        pkg=(EditText)act.findViewById(R.id.pkg);
        cls=(EditText)act.findViewById(R.id.cls);
        type=(EditText)act.findViewById(R.id.type);
        extras=(EditText)act.findViewById(R.id.extras);
        result=(EditText)act.findViewById(R.id.result);
        button=(Button)act.findViewById(R.id.inputComplete);
    }
    //Qb^[
    public String getAction(){return action.getText().toString();}
    public String getData(){return data.getText().toString();}
    public String getCategory(){return category.getText().toString();}
    public String getPkg(){return pkg.getText().toString();}
    public String getCls(){return cls.getText().toString();}
    public String getType(){return type.getText().toString();}
    public String getExtras(){return extras.getText().toString();}
    public String getResult(){return result.getText().toString();}
    
    public void setResult(String result){this.result.setText(result);}
    public void setContextMenu(){act.registerForContextMenu(button);}
    //_CAO
    public void dialogInput(View v){
    	switch(v.getId()){
    	//Action̓
    	case R.id.action:
    		final String[] actList=act.getResources().getStringArray(R.array.actList);
    		new AlertDialog.Builder(act)
    		.setIcon(R.drawable.icon)
    		.setTitle(R.string.actTitle)
    		.setItems(actList, new DialogInterface.OnClickListener() {				
				public void onClick(DialogInterface dialog, int which) {
					action.setText(actList[which]);
					if(actList[which].equals("VK")){
						final EditText textbox=new EditText(act);
						action.setText("");
						new AlertDialog.Builder(act)
			    		.setIcon(R.drawable.icon)
			    		.setTitle(R.string.actTitle)
			    		.setView(textbox)
			    		.setPositiveButton("", new DialogInterface.OnClickListener() {
			    			public void onClick(DialogInterface dialog, int no) {
								action.setText(textbox.getText().toString());
			    			}
			    		})
						.show();
					}
				}
			})
    		.show();
    		break;
    	//Category̓
    	case R.id.category:
    		final String[] catList=act.getResources().getStringArray(R.array.catList);
    		new AlertDialog.Builder(act)
    		.setIcon(R.drawable.icon)
    		.setTitle(R.string.catTitle)
    		.setItems(catList, new DialogInterface.OnClickListener() {				
				public void onClick(DialogInterface dialog, int which) {
					category.setText(catList[which]);					
					if(catList[which].equals("VK")){
						category.setText("");	
						final EditText textbox=new EditText(act);
						new AlertDialog.Builder(act)
			    		.setIcon(R.drawable.icon)
			    		.setTitle(R.string.catTitle)
			    		.setView(textbox)
			    		.setPositiveButton("", new DialogInterface.OnClickListener() {
			    			public void onClick(DialogInterface dialog, int no) {
			    				category.setText(textbox.getText().toString());
			    			}
			    		})
						.show();
					}
				}
			})
    		.show();
    		break;
    	}
    }
}